//Julia Fraktale mit Farbtafel, Complex und MT
ArrayList<Threads> threads;
FarbTafel farben;
Complex zNeu,zAlt,C,M,z0,z1,z,zA,zB;
double xU = -3; 
double yU = -3; 
double xO = 3;
double yO = 3;
double zoomFaktor=1;
double wh = xO-xU;
double laenge,cL,mL,cQL;
double mX,mY;
double x0,y0;
double r,s,t;
double rMax,sMax,tMax;
int VZ;
int qH =3;//höchster Exp von Q
float zufall;
int maxiterations = 512;
double massFuerUnendlich = 1000; 
float zeroOrOne;
float f1080=1;
float f8192=1;
boolean bunt=false;
boolean mitWS = true;
int nummerThread;
int anzahlThreads = Runtime.getRuntime().availableProcessors(); 
char hG ='w';
int nBD = 0;//Ausstieg aus Iteration an Stelle nullBisDrei
boolean Julia;
boolean konvergGemeldet = false;

void setup() {
  background(255);
  noLoop();
  colorMode(RGB);
  threads = new  ArrayList<Threads>(); 
  farben= new FarbTafel(); 
  farben.setHintergrund(hG); 
  farben.farbTafelErzeugen();
  size(1200, 1200);
  Julia = true;
  zAlt = new Complex(0,0); 
  zNeu = new Complex(0,0);
  x0 = Math.random();y0 = Math.random();
  x0 = 1.8*(x0-0.5); y0 = 1.8*(y0-0.5);
  println("x0: "+x0+" y0: "+y0);
   //x0= 0.25; y0 =-0.5642857551574707;
  //x0 = -0.22500038146972656 ;  y0 = 0.1821427345275879 ; 
  C = new Complex(x0,y0);
  cL = C.getLength();
  cQL = C.power(qH-2).getLength();
  
  zufall = random(-1,1);
  if(zufall>=0)VZ=1;
  else VZ =-1;
  mX = VZ*3*Math.random();
  
  zufall = random(-1,1);
  if(zufall>=0)VZ=1;
  else VZ =-1;
  mY = VZ*3*Math.random();
  M = new Complex(mX,mY);
  mL= M.getLength();

  println("M: "+mX,mY);
  
  r = Math.random();s =  Math.random();t =  Math.random();
  println("r: "+r+" s: "+s+" t: "+t);
    
 
  nummerThread =0;
  starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread, C, Julia);
  
}

/////////////////////////////////////////////////////////////////

void starteThreads(double px, double py, int pmaxiterations, double pUnendlich, double pwh, int nummer, Complex c, boolean julia){
  
  xU = px; yU = py;
  C = c;
  julia = Julia;
  nummerThread = nummer;
  maxiterations = pmaxiterations;
  massFuerUnendlich = pUnendlich;
  wh = pwh;//println(wh/anzahlThreads); double y= yU;
  double  y= yO-wh/anzahlThreads;
  while(nummerThread <anzahlThreads){
        Threads t = new Threads(xU,y,maxiterations,massFuerUnendlich,wh/anzahlThreads, nummerThread,C, julia);
        //println(xU,y,maxiterations,massFuerUnendlich,wh/anzahlThreads, nummerThread);
        threads.add(t);
        t.start(); 
        nummerThread++;
        y=y-wh/anzahlThreads;
        //delay(5);//zur Verringerung der Pixelfehler
    
  }
  
}
//////////////////////////////////////////////////////////////

void draw() {
  
  // die Draw-Methode fügt die PGraphics-Zeichenflächen
  // der Threads zu einem Bild zusammen
  // Warten bis alle Threads fertig sind
 
  for(Threads t: threads){
      while (t.running){       
            try{
            Thread.sleep(10);  
            }catch (Exception e) {  }  ;                
       }
  }
  
  for (int i=0; i<threads.size(); i++){
    image(threads.get(i).pg,0,i*height/anzahlThreads);   
  }  
  println("Fertig!"); 
}

/////////////////////////////////////////////////////////////////
void mousePressed() { 
     nummerThread =0;
     threads = new  ArrayList<Threads>(); 
     double xUNeu, xONeu, yUNeu, yONeu;//Temp. Speicher
     
     if (mouseButton == LEFT){
        xUNeu = map(mouseX,0,width,(float)xU,(float)xO)-(xO-xU)/10;
        xONeu = map(mouseX,0,width,(float)xU,(float)xO)+(xO-xU)/10; 
        xU = xUNeu; xO = xONeu; 
        //println(xU,xO);
        yUNeu = map(mouseY,height,0,(float)yU,(float)yO)-(yO-yU)/10;
        yONeu = map(mouseY,height,0,(float)yU,(float)yO)+(yO-yU)/10; 
        yU =yUNeu; yO = yONeu; 
        wh = wh/5;
        zoomFaktor =zoomFaktor*5;
        println("Zoomfaktor: "+zoomFaktor);
        starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,C, Julia);
  
        redraw();
     }
     
     if (mouseButton == RIGHT){   
           Julia = true;
           x0 = map(mouseX,0,width,(float)xU,(float)xO);
           y0 = map(mouseY,height,0,(float)yU,(float)yO);
           C = new Complex(x0,y0);
           println("x0 = "+x0+" ; "+" y0 = "+y0+" ; ");
           starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,C, Julia);
  
           redraw();          
     }
}  
/////////////////////////////////////////////////////////////////
void keyPressed() {
  Julia = true;
  if (key == 'm'){
     Julia = false;
     println("Mandelbrot");
  }  
  if (key == '0'){
     if(hG=='s')hG='w';
     else if(hG=='w')hG='s';
     farben.setHintergrund(hG);
     farben.farbTafelErzeugen();
     println("Hintergrundfarbe: "+hG);
  }
  if (key == '1'){
       x0 = 0.4700002670288086 ;  y0 = 0.9099998474121094 ; 
      println("x0 = "+x0+" ; "+" y0 = "+y0+" ; ");    
  }
  if (key == '2'){
      qH = 2;
      println("maximaler Exponent: "+qH);
  }
  if (key == '3'){
      qH = 3;
      println("maximaler Exponent: "+qH);
  }
  if (key == '4'){
      qH = 4;
      println("maximaler Exponent: "+qH);
  }
  if (key == '5'){
      qH = 5;
      println("maximaler Exponent: "+qH);
  }
  if (key == '6'){
      qH = 6;
      println("maximaler Exponent: "+qH);
  }
  if (key == '7'){
      qH = 7;
      println("maximaler Exponent: "+qH);
  }
  if (key == '8'){
      qH = 8;
      println("maximaler Exponent: "+qH);
  }
  if(key == 'f'){
      f1080 = 1.2*f1080;
      println("Farbfaktor bei MaxIter = "+f1080);
  }
  if(key == 'k'){
      f1080 = f1080/1.2;
      println("Farbfaktor bei MaxIter = "+f1080);
  }
  if(key == 'v'){
      f8192 = 1.2*f8192;
      println("Farbfaktor8192: "+f8192);
  }
  if(key == 'w'){
      f8192 = f8192/1.2;
      println("Farbfaktor8192: "+f8192);
  }
  if(key == '+'){
     maxiterations *= 1.2; println("Iterationsgrenze: "+maxiterations);
  }
  if(key == '-') {
      maxiterations /= 1.2;println("Iterationsgrenze: "+maxiterations);
  }
  if(key == 'ß'){
     massFuerUnendlich = 1.5*massFuerUnendlich;
     f8192 = 256.0/(float)massFuerUnendlich;//Anzahl Farbabstufungen
     println("MaßFuerUnendlich = "+massFuerUnendlich+ " Farbfaktor8192: "+f8192);
  }
  if (key == 'z'){
     double xUNeu, xONeu, yUNeu, yONeu;//Temp. Speicher
     xUNeu = xU+0.25*(xO-xU);yUNeu = yU+0.25*(yO-yU);
     xONeu = xO-0.25*(xO-xU);yONeu = yO-0.25*(yO-yU);
     xU = xUNeu; xO = xONeu; 
     yU = yUNeu; yO = yONeu; 
     wh=wh/2;
     zoomFaktor =zoomFaktor*2;
     println("Zoomfaktor: "+zoomFaktor);
  }
  if (key == 'p'){
     double xUNeu, xONeu, yUNeu, yONeu;//Temp. Speicher
     xUNeu = xU-0.125*(xO-xU);yUNeu = yU-0.125*(yO-yU);
     xONeu = xO+0.125*(xO-xU);yONeu = yO+0.125*(yO-yU);
     xU = xUNeu;xO = xONeu; 
     yU = yUNeu;yO = yONeu; 
     wh=wh*1.25;
     zoomFaktor =zoomFaktor/1.25;
     println("Zoomfaktor: "+zoomFaktor);
  }
  if (key == 'l'){
     xO = xO + wh/10;
     xU = xU + wh/10;
     println("Verschiebung nach Links");
  }
  if (key == 'r'){
     xO = xO - wh/10;
     xU = xU - wh/10;
     println("Verschiebung nach Rechts");
  }
   if (key == 'u'){
     yO = yO + wh/10;
     yU = yU + wh/10;
     println("Verschiebung nach unten");
  }
  if (key == 'o'){
     yO = yO - wh/10;
     yU = yU - wh/10;
     println("Verschiebung nach oben");
  }
  if (key == 'b'){
     bunt = !bunt;
     println("Konvergenz bonbonfarbig: "+bunt);
  }
  if (key == 'q'){
    nBD = (nBD+1) % 4;
    println("Anzahl Mehrfachiteration: "+nBD);
  }
  if (key == 'a'){
     mitWS = !mitWS;
     println("Mit Winkel- und Streckensumme: "+mitWS);
  }
  nummerThread =0;
  threads = new  ArrayList<Threads>(); 
  starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,C, Julia);
  redraw();
  
  if (key == 's') save("JuliaMandelEscapeExp.jpg");
}
/////////////////////////////////////////////////////////////////
